#!/usr/bin/ruby
$:.unshift File.join(File.dirname(__FILE__))

# Form implementation generated from reading ui file 'podnovasync.ui'
#
# Created: Sat Jun 2 18:44:02 2007
#      by: The QtRuby User Interface Compiler (rbuic)
#
# WARNING! All changes made in this file will be lost!


require 'Korundum'
require 'net/http'

class PodnovaOpmlConfig < Qt::Widget

    slots 'testUrl()', 'saveUrl()'
    attr_reader :lineEdit1
    attr_reader :testButton
    attr_reader :saveButton
    attr_reader :resultText
    attr_reader :inputLabel


    def initialize(parent = nil, name = nil, fl = 0)
        super

        if name.nil?
        	setName("PodnovaOpmlConfig")
        end

        @podNovaUrl = ""

        @lineEdit1 = Qt::LineEdit.new(self, "lineEdit1")
        @lineEdit1.setGeometry( Qt::Rect.new(160, 50, 270, 22) )

        @testButton = Qt::PushButton.new(self, "testButton")
        @testButton.setGeometry( Qt::Rect.new(450, 50, 70, 24) )

        @saveButton = Qt::PushButton.new(self, "saveButton")
        @saveButton.setGeometry( Qt::Rect.new(410, 270, 112, 24) )

        @resultText = Qt::TextView.new(self, "resultText")
        @resultText.setGeometry( Qt::Rect.new(50, 90, 451, 161) )

        @inputLabel = Qt::Label.new(self, "inputLabel")
        @inputLabel.setGeometry( Qt::Rect.new(20, 50, 120, 20) )

        connect( @testButton, SIGNAL('clicked()'), self, SLOT( 'testUrl()' ) )
        connect( @saveButton, SIGNAL('clicked()'), self, SLOT( 'saveUrl()' ) )

        languageChange()
        resize( Qt::Size.new(568, 320).expandedTo(minimumSizeHint()) )
        clearWState( WState_Polished )
    end
    
    def testUrl
        @podNovaUrl = @lineEdit1.text()
        Thread.new(@podNovaUrl) { |myPage|
            req = Net::HTTP.get_response(URI.parse(myPage))
            @resultText.setText(req.body)
        }
    end
    
    def saveUrl
        puts "Saving URL"
        conf_file = File.open("./synpodnova.conf", "w")
        conf_file.truncate(0)
        conf_file.write("opmlUrl=" + @podNovaUrl + "\n")
        conf_file.close
        Qt::Application.exit( 0 )
    end

    #
    #  Sets the strings of the subwidgets using the current
    #  language.
    #
    def languageChange()
        setCaption(trUtf8("Podnova OPML Sync Config"))
        @testButton.setText( trUtf8("Test") )
        @testButton.setAccel(Qt::KeySequence.new(nil))
        @saveButton.setText( trUtf8("S&ave") )
        @saveButton.setAccel( Qt::KeySequence.new(trUtf8("Alt+A")) )
        @inputLabel.setText( trUtf8("Podnova OPML URL") )
        Qt::ToolTip.add( @inputLabel, nil )
    end
    protected :languageChange


end

